import 'dart:convert';
import 'package:flutter/material.dart';
import 'package:nudge_leaderboard_ui/features/leaderboard/data/models/create_user.dart';
import 'package:dio/dio.dart' as dio;

Future<CreateUser> createuserrequest(String token, String? externalId,
    {Map<String, dynamic>? props}) async {
  var headers = {'authorization': token, 'Content-Type': 'application/json'};

  var mapData = props ?? {};

  mapData["externalId"] = externalId;
  var data = json.encode(mapData);

  var request = dio.Dio();
  var response = await request.request(
    'https://pointsystem.api.nudgenow.com/api/v1/users/u/create',
    options: dio.Options(
      method: 'POST',
      headers: headers,
    ),
    data: data,
  );

  if (response.statusCode == 201) {
    return CreateUser.fromJson(response.data);
  } else {
    debugPrint(response.statusMessage);
    throw Exception('Failed to get create user data');
  }
}
