import 'dart:convert';
import 'package:flutter/material.dart';

import '../models/track_event.dart';
import 'package:dio/dio.dart' as dio;

Future<TrackLeaderboardEvent> trackEventRequest(
    String userAuthorisationToken) async {
  var headers = {
    'authorization': userAuthorisationToken,
    'Content-Type': 'application/json'
  };

  var data = json.encode({
    "sessionId": "6y08052-198a-21we-a03c-75a7b91",
    "type": "streak_event",
    "platform": "flutter",
    "status": "inactive"
  });

  var request = dio.Dio();
  var response = await request.request(
    'https://pointsystem.api.nudgenow.com/api/v1/events/e/track',
    options: dio.Options(
      method: 'POST',
      headers: headers,
    ),
    data: data,
  );

  if (response.statusCode == 200) {
    return TrackLeaderboardEvent.fromJson(response.data);
  } else {
    debugPrint(response.statusMessage);
    throw Exception('Failed to track Event data');
  }
}
