import 'dart:convert';

CreateUser createUserFromJson(String str) =>
    CreateUser.fromJson(json.decode(str));

String createUserToJson(CreateUser data) => json.encode(data.toJson());

class CreateUser {
  String status;
  Data data;

  CreateUser({
    required this.status,
    required this.data,
  });

  factory CreateUser.fromJson(Map<String, dynamic> json) => CreateUser(
        status: json["status"],
        data: Data.fromJson(json["data"]),
      );

  Map<String, dynamic> toJson() => {
        "status": status,
        "data": data.toJson(),
      };
}

class Data {
  String id;
  String deviceId;
  String name;
  String email;
  String phoneNumber;
  dynamic referredBy;
  dynamic referrerCode;
  int usersReferred;
  String referralCode;
  dynamic referralCodeExpiry;
  String externalId;
  int score;
  String clientId;
  String shareId;
  String token;
  List<dynamic> tags;
  List<dynamic> tasks;
  List<dynamic> rewards;
  String photoUrl;
  List<dynamic> streaks;
  Properties properties;
  DateTime createdAt;
  DateTime updatedAt;
  int v;

  Data({
    required this.id,
    required this.deviceId,
    required this.name,
    required this.email,
    required this.phoneNumber,
    required this.referredBy,
    required this.referrerCode,
    required this.usersReferred,
    required this.referralCode,
    required this.referralCodeExpiry,
    required this.externalId,
    required this.score,
    required this.clientId,
    required this.shareId,
    required this.token,
    required this.tags,
    required this.tasks,
    required this.rewards,
    required this.photoUrl,
    required this.streaks,
    required this.properties,
    required this.createdAt,
    required this.updatedAt,
    required this.v,
  });

  factory Data.fromJson(Map<String, dynamic> json) => Data(
        id: json["_id"],
        deviceId: json["deviceId"],
        name: json["name"],
        email: json["email"],
        phoneNumber: json["phoneNumber"],
        referredBy: json["referredBy"],
        referrerCode: json["referrerCode"],
        usersReferred: json["usersReferred"],
        referralCode: json["referralCode"],
        referralCodeExpiry: json["referralCodeExpiry"],
        externalId: json["externalId"],
        score: json["score"],
        clientId: json["clientId"],
        shareId: json["shareId"],
        token: json["token"],
        tags: List<dynamic>.from(json["tags"].map((x) => x)),
        tasks: List<dynamic>.from(json["tasks"].map((x) => x)),
        rewards: List<dynamic>.from(json["rewards"].map((x) => x)),
        photoUrl: json["photoUrl"],
        streaks: List<dynamic>.from(json["streaks"].map((x) => x)),
        properties: Properties.fromJson(json["properties"]),
        createdAt: DateTime.parse(json["createdAt"]),
        updatedAt: DateTime.parse(json["updatedAt"]),
        v: json["__v"],
      );

  Map<String, dynamic> toJson() => {
        "_id": id,
        "deviceId": deviceId,
        "name": name,
        "email": email,
        "phoneNumber": phoneNumber,
        "referredBy": referredBy,
        "referrerCode": referrerCode,
        "usersReferred": usersReferred,
        "referralCode": referralCode,
        "referralCodeExpiry": referralCodeExpiry,
        "externalId": externalId,
        "score": score,
        "clientId": clientId,
        "shareId": shareId,
        "token": token,
        "tags": List<dynamic>.from(tags.map((x) => x)),
        "tasks": List<dynamic>.from(tasks.map((x) => x)),
        "rewards": List<dynamic>.from(rewards.map((x) => x)),
        "photoUrl": photoUrl,
        "streaks": List<dynamic>.from(streaks.map((x) => x)),
        "properties": properties.toJson(),
        "createdAt": createdAt.toIso8601String(),
        "updatedAt": updatedAt.toIso8601String(),
        "__v": v,
      };
}

class Properties {
  String name;
  String email;
  String externalId;
  String clientId;

  Properties({
    required this.name,
    required this.email,
    required this.externalId,
    required this.clientId,
  });

  factory Properties.fromJson(Map<String, dynamic> json) => Properties(
        name: json["name"],
        email: json["email"],
        externalId: json["externalId"],
        clientId: json["clientId"],
      );

  Map<String, dynamic> toJson() => {
        "name": name,
        "email": email,
        "externalId": externalId,
        "clientId": clientId,
      };
}
