// To parse this JSON data, do
//
//     final getAllLeaderboardRewards = getAllLeaderboardRewardsFromJson(jsonString);

import 'dart:convert';
import 'package:dio/dio.dart' as dio;

GetAllLeaderboardRewards getAllLeaderboardRewardsFromJson(String str) =>
    GetAllLeaderboardRewards.fromJson(json.decode(str));

String getAllLeaderboardRewardsToJson(GetAllLeaderboardRewards data) =>
    json.encode(data.toJson());

class GetAllLeaderboardRewards {
  String status;
  List<Datum> data;

  GetAllLeaderboardRewards({
    required this.status,
    required this.data,
  });

  factory GetAllLeaderboardRewards.fromJson(Map<String, dynamic> json) =>
      GetAllLeaderboardRewards(
        status: json["status"],
        data: List<Datum>.from(json["data"].map((x) => Datum.fromJson(x))),
      );

  Map<String, dynamic> toJson() => {
        "status": status,
        "data": List<dynamic>.from(data.map((x) => x.toJson())),
      };
}

Future<GetAllLeaderboardRewards> getallleaderboardrewards(
  String authToken,
  String apiUrl,
) async {
  var headers = {'authorization': authToken};
  var request = dio.Dio();
  var response = await request.request(
    apiUrl,
    options: dio.Options(
      method: 'GET',
      headers: headers,
    ),
  );

  if (response.statusCode == 200) {
    return GetAllLeaderboardRewards.fromJson(response.data);
  } else {
    throw Exception('Failed to fetch leaderboard rewards data');
  }
}

class Datum {
  String id;
  String name;
  String rewardType;
  String status;
  String? code;
  String desc;
  dynamic cardData;
  int value;
  String clientId;
  String iconId;
  DateTime createdAt;
  DateTime updatedAt;
  int v;
  int? scoreValue;
  List<String>? usedIn;

  Datum({
    required this.id,
    required this.name,
    required this.rewardType,
    required this.status,
    required this.code,
    required this.desc,
    this.cardData,
    required this.value,
    required this.clientId,
    required this.iconId,
    required this.createdAt,
    required this.updatedAt,
    required this.v,
    this.scoreValue,
    this.usedIn,
  });

  factory Datum.fromJson(Map<String, dynamic> json) => Datum(
        id: json["_id"],
        name: json["name"],
        rewardType: json["rewardType"],
        status: json["status"],
        code: json["code"],
        desc: json["desc"],
        cardData: json["cardData"],
        value: json["value"],
        clientId: json["clientId"],
        iconId: json["iconId"],
        createdAt: DateTime.parse(json["createdAt"]),
        updatedAt: DateTime.parse(json["updatedAt"]),
        v: json["__v"],
        scoreValue: json["scoreValue"],
        usedIn: json["usedIn"] == null
            ? []
            : List<String>.from(json["usedIn"]!.map((x) => x)),
      );

  Map<String, dynamic> toJson() => {
        "_id": id,
        "name": name,
        "rewardType": rewardType,
        "status": status,
        "code": code,
        "desc": desc,
        "cardData": cardData,
        "value": value,
        "clientId": clientId,
        "iconId": iconId,
        "createdAt": createdAt.toIso8601String(),
        "updatedAt": updatedAt.toIso8601String(),
        "__v": v,
        "scoreValue": scoreValue,
        "usedIn":
            usedIn == null ? [] : List<dynamic>.from(usedIn!.map((x) => x)),
      };
}
