// To parse this JSON data, do
//
//     final trackEvent = trackEventFromJson(jsonString);

import 'dart:convert';

TrackLeaderboardEvent trackEventFromJson(String str) =>
    TrackLeaderboardEvent.fromJson(json.decode(str));

String trackEventToJson(TrackLeaderboardEvent data) => json.encode(data.toJson());

class TrackLeaderboardEvent {
  String status;
  Data data;

  TrackLeaderboardEvent({
    required this.status,
    required this.data,
  });

  factory TrackLeaderboardEvent.fromJson(Map<String, dynamic> json) => TrackLeaderboardEvent(
        status: json["status"],
        data: Data.fromJson(json["data"]),
      );

  Map<String, dynamic> toJson() => {
        "status": status,
        "data": data.toJson(),
      };
}

class Data {
  Properties properties;
  String type;
  String userId;
  String clientId;
  DateTime occuredAt;
  String sessionId;
  String id;
  List<dynamic> tasksCompleted;
  List<dynamic> rewardsWon;
  int newScore;
  List<Campaign> campaigns;
  List<dynamic> tasksNotCompleted;
  List<dynamic> gameZones;
  List<dynamic> referralSystems;

  Data({
    required this.properties,
    required this.type,
    required this.userId,
    required this.clientId,
    required this.occuredAt,
    required this.sessionId,
    required this.id,
    required this.tasksCompleted,
    required this.rewardsWon,
    required this.newScore,
    required this.campaigns,
    required this.tasksNotCompleted,
    required this.gameZones,
    required this.referralSystems,
  });

  factory Data.fromJson(Map<String, dynamic> json) => Data(
        properties: Properties.fromJson(json["properties"]),
        type: json["type"],
        userId: json["userId"],
        clientId: json["clientId"],
        occuredAt: DateTime.parse(json["occuredAt"]),
        sessionId: json["sessionId"],
        id: json["id"],
        tasksCompleted:
            List<dynamic>.from(json["tasksCompleted"].map((x) => x)),
        rewardsWon: List<dynamic>.from(json["rewardsWon"].map((x) => x)),
        newScore: json["newScore"],
        campaigns: List<Campaign>.from(
            json["campaigns"].map((x) => Campaign.fromJson(x))),
        tasksNotCompleted:
            List<dynamic>.from(json["tasksNotCompleted"].map((x) => x)),
        gameZones: List<dynamic>.from(json["gameZones"].map((x) => x)),
        referralSystems:
            List<dynamic>.from(json["referralSystems"].map((x) => x)),
      );

  Map<String, dynamic> toJson() => {
        "properties": properties.toJson(),
        "type": type,
        "userId": userId,
        "clientId": clientId,
        "occuredAt": occuredAt.toIso8601String(),
        "sessionId": sessionId,
        "id": id,
        "tasksCompleted": List<dynamic>.from(tasksCompleted.map((x) => x)),
        "rewardsWon": List<dynamic>.from(rewardsWon.map((x) => x)),
        "newScore": newScore,
        "campaigns": List<dynamic>.from(campaigns.map((x) => x.toJson())),
        "tasksNotCompleted":
            List<dynamic>.from(tasksNotCompleted.map((x) => x)),
        "gameZones": List<dynamic>.from(gameZones.map((x) => x)),
        "referralSystems": List<dynamic>.from(referralSystems.map((x) => x)),
      };
}

class Campaign {
  String campaignId;
  String gameKey;
  String gameSettingsId;
  dynamic userStatId;
  String position;
  dynamic createdAt;
  dynamic noOfTries;

  Campaign({
    required this.campaignId,
    required this.gameKey,
    required this.gameSettingsId,
    required this.userStatId,
    required this.position,
    required this.createdAt,
    required this.noOfTries,
  });

  factory Campaign.fromJson(Map<String, dynamic> json) => Campaign(
        campaignId: json["campaignId"],
        gameKey: json["gameKey"],
        gameSettingsId: json["gameSettingsId"],
        userStatId: json["userStatId"],
        position: json["position"],
        createdAt: json["createdAt"],
        noOfTries: json["noOfTries"],
      );

  Map<String, dynamic> toJson() => {
        "campaignId": campaignId,
        "gameKey": gameKey,
        "gameSettingsId": gameSettingsId,
        "userStatId": userStatId,
        "position": position,
        "createdAt": createdAt,
        "noOfTries": noOfTries,
      };
}

class Properties {
  String sessionId;
  String type;
  String platform;
  String status;

  Properties({
    required this.sessionId,
    required this.type,
    required this.platform,
    required this.status,
  });

  factory Properties.fromJson(Map<String, dynamic> json) => Properties(
        sessionId: json["sessionId"],
        type: json["type"],
        platform: json["platform"],
        status: json["status"],
      );

  Map<String, dynamic> toJson() => {
        "sessionId": sessionId,
        "type": type,
        "platform": platform,
        "status": status,
      };
}
